function [f x c] = multiTaylor(F,n) 
  % given derivative matrix F, construct symbolic taylor series of order n
  % that takes symbolic arguments 'x' 
  % c is a vector of all symbolic coefficients used
  
  nOut = size(F,1); % dimension of f()
  nIn = ndims(F)-1; % dimension of args
                   % so, f: R^nIn -> R^nOut
  n=n+1;                
  % construct arguments
  for i=1:nIn
     x(i) = sym(sprintf('x%d',i));
  end

  aold = zeros(nIn^(n-2),nIn);
  a = ones(nIn^(n-1),nIn); 
  % a will be all n-tuples of positive integers such that sum(a(i,:))=d-1

  % initialize f to zeros order expansion
  ind = sprintf(',%d',a(1,:));
  ind = ind(2:length(ind));
  eval(sprintf('f = F(:,%s);',ind));
  eval(sprintf('c = F(:,%s);',ind));
  %f = F(:,a(1,:));
  % build taylor series
  for d=2:n
    aold(1:nIn^(d-2),:) = a(1:nIn^(d-2),:);
    j=1;
    for o=1:nIn^(d-2)
        for i=1:nIn
            a(j,:) = aold(o,:);
            a(j,i) = aold(o,i)+1;
            j = j+1;
        end
    end
    assert(j==nIn^(d-1)+1);
    for j=1:nIn^(d-1)
      ind = sprintf(',%d',a(j,:));
      ind = ind(2:length(ind));
      eval(sprintf('f = f+F(:,%s)*prod(x.^(a(j,:)-1)./(factorial(a(j,:)-1)));',ind));
      eval(sprintf('c = [c; F(:,%s)];',ind));
    end
  end
end % function multiTaylor()

    